/*---------------------------------------------------------------------------
 *
 *      Title:          Memory Allocation tracking and checking
 *
 *      File:           dyn_valxx.cpp
 *
 *      Creation Date:  May 1996
 *
 *      Description:
 *             Provide the new/delete operators for C++. Not terribly elegant, 
 *      *but* it does work.
 *
 *      Data sources:
 *            None.
 *
 *      1.0     R.J.Harrison    Implement                        May      1996
 *
 *      Copyright  1996 R.J.Harrison
 *---------------------------------------------------------------------------*/

#include "dyn_val.h"

#if 1
//
// New routines for delete and new to track (well check)...
static char *mod="C++ new";
static int mod_line=0;

void *DV_new_set_id(char *fn, int line)
{
	mod = fn;
	mod_line = line;
	return 0;
}

void *operator new (unsigned int ch)
{
	if (!ch)
		ch++;
	if (mod)
	{
		void *x=DV_malloc(ch,mod, mod_line);
		mod=0;
		mod_line=0;
		return x;
	}
	else
		return DV_malloc(ch,"C++ new",0);
}

void operator delete (void *cp)
{
	if (cp)
		DV_free(cp,"C++ delete",0);
}
  

  
#else

//
// New routines for delete and new to track (well check)...
static long sz;
static void *ptr;

void *new_log(char *fn, int line)
{
DV_track (sz, ptr, fn, line);
return 0;
}


void *operator new (unsigned int ch)
{
	if (!ch)
		ch++;
	void *x=DV_get (ch);
	sz = ch;
	ptr=x;
	return x;
}

void operator delete (void *cp)
{
	if (cp)
		DV_free(cp,"C++ delete",0);
}
#endif

